#!/usr/bin/perl

require 5;

use strict;
use integer;
use vars qw(%config %in %text);
use Exim;
#use LogRotate::Read;

do '../web-lib.pl'; # Required by Webmin
init_config();      # Initiate the Webmin stuff

require './module-lib.pl';

ReadParse();

my @logs = ( 'main', 'panic', 'reject' );

my $section = ($config{log_default} or 'main');
my $lines = ($config{log_lines} or 20);

if (exists $in{log}) {
  $section = parse_CGI ($in{log}, 8, 'a-z', @logs) or redirect("/$::module_name"), exit(1);
}

if (exists $in{lines}) {
  my $temp_lines = parse_CGI ($in{lines}, 4, '0-9');
  if (int $temp_lines > 0) {
    $lines = int $temp_lines
  }
  else {
    redirect("/$::module_name");
    exit(1);
  }
}

header($text{log_title}, '');
print '<hr/>', "\n";

my $exim = Exim->new(exec=>$config{exec_path}, conf=>$config{conf_path});
my $log_files_path = $exim->log_files_path();

log_links($section);

my $logfile = $log_files_path;
$logfile =~ s/%s/$section/;

print '<pre>', "\n";
#my $log = LogRotate::Read->new;
my $log = FileHandle->new;
$log->open($logfile) or die "Unable to open log file: $logfile\n";

my @lines = $log->getlines;

{
  my $start = 0;
  $start = $#lines - $lines + 1  if $#lines-$lines > 0;
  print map { html_escape($_) } @lines[$start..$#lines];
}

$log->close;
print '</pre>', "\n";

print '<form action="logs.cgi" method="post">', "\n";
print "<input type=\"hidden\" name=\"log\" value=\"$section\"/>\n";
print &text ('log_info',
	     "<input type=\"text\" name=\"lines\" size=\"3\" value=\"$lines\">",
	     "<tt>$logfile</tt>"), "\n";

print '<button type="submit">', $text{log_refresh}, '</button><br/>', "\n";
print '</form><hr/>', "\n";
footer('', $text{index_title});
1;

sub log_links
{
  my $current_log = shift;

  print '<b>', $text{log_choose}, ':</b>&nbsp;&nbsp;', "\n";
  foreach my $log (@logs) {
    if ($log eq $current_log) {
      print "<b>$log</b>";
    }
    else {
      my $logfile = $log_files_path;
      $logfile =~ s/%s/$log/;
      if (-s "$logfile") {
	print "<a href=\"logs.cgi?log=$log\">$log</a>";
      }
      else {
	print "<span style=\"text-decoration:line-through\">$log</span>";
      }
    }
    print '&nbsp;'
  }
  print '<hr/>', "\n"
}
